<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="width=320; user-scalable=no" />
    <meta http-equiv="Content-type" content="text/html; charset=utf-8">
    <title>PhoneGap - AccelerometerSample</title>
	<style type="text/css">
		*{
			margin: 0px;
			padding: 0px;
		}
	</style>
	<script type="text/javascript" src="js.lib/phonegap-1.2.0.js"></script>
	<script type="text/javascript">
<!--
var displayWidth;		// ディスプレイ幅
var displayHeight;		// ディスプレイ高さ
var displayCanvas;	// キャンバスオブジェクト
var accWatchID;		// 加速度センサーイベントID

// 球のパラメータ
var circle = {
	radius: 20,	// 半径
	x: null,	// X位置
	y: null		// Y位置
};

window.onload = function() {
	document.addEventListener('deviceready', onDeviceReady, false);
	
	// ディスプレイ情報を取得
	displayWidth = window.innerWidth;
	displayHeight = window.innerHeight;
	
	// キャンバスの大きさを調整
	document.getElementById('mainCanvas').width = displayWidth;
	document.getElementById('mainCanvas').height = displayHeight;

	// 球オブジェクトの位置をキャンバスの中心に設定
	circle.x = displayWidth / 2;
	circle.y = displayHeight / 2;
	
	render();
};

// ネイティブデバイスとの連携が出来たタイミング
function onDeviceReady() {
	// キャンバスオブジェクトを代入
	displayCanvas = document.getElementById('mainCanvas');
	
	// 描画メソッド
	render();	
	
	// 加速度センサー受信開始
	accWatchID = navigator.accelerometer.watchAcceleration(watchAccelerometer,
		function () { // onErrorメソッド
			alert("加速度センサー連携エラー");
		}
	, { frequency: 60/1000 }); // 60/1000ms毎に加速度センサの値を取得
}

// 描画メソッド
function render() {
	
	if ( ! displayCanvas || ! displayCanvas.getContext ) {	
		return false;
	}
	
	var ctx = displayCanvas.getContext('2d');
	ctx.beginPath();
	ctx.clearRect(0,0,displayWidth,displayHeight);	// 画面をクリア
	
	// 球オブジェクトを描画
	ctx.arc(circle.x, circle.y, circle.radius, 0, Math.PI*2, true);
	ctx.fill();
}

// 加速度センサーのコールバックメソッド
function watchAccelerometer(acceleration) {
	
	// 移動処理
	circle.x -= acceleration.x * 2.5;
	circle.y += acceleration.y * 2.5;
	
	// 球が画面外に出た時の処理(x座標)
	if(circle.x < 0 + circle.radius) {
		circle.x = 0 + circle.radius;
	} else if(circle.x > displayWidth - circle.radius) {
		circle.x = displayWidth - circle.radius;
	}
	
	// 球が画面外に出た時の処理(y座標)
	if(circle.y < 0 + circle.radius) {
		circle.y = 0 + circle.radius;
	} else if(circle.y > displayHeight - circle.radius) {
		circle.y = displayHeight - circle.radius;
	}
	
	render();
}

// -->
		</script>
	</head>
	<body>
		<canvas id="mainCanvas" width="320px" style="background-color: #ddd;"></canvas>
	</body>
</html>
